var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { bindActionCreators } from 'redux';
export function connect(store, mapStateToData, mapDispatchToStore) {
    function mapStateToData$(state) {
        var mapped = mapStateToData(state);
        return Object.keys(mapped).reduce(function (data, key) {
            return (__assign({}, data, (_a = {}, _a['$' + key] = mapped[key], _a)));
            var _a;
        }, {});
    }
    return function () {
        if (store == null) {
            return { _init: function () { return ({}); } };
        }
        var svelteStore = {
            _init: function () {
                return mapStateToData$(store.getState());
            },
            _add: function (component, keys) {
                svelteStore._unsub = store.subscribe(function () {
                    component.set(mapStateToData$(store.getState()));
                });
            },
            _remove: function (component) {
                if (svelteStore._unsub != null) {
                    svelteStore._unsub();
                }
            },
        };
        if (mapDispatchToStore == null) {
            Object.assign(svelteStore, { dispatch: store.dispatch });
        }
        else if (typeof mapDispatchToStore === 'function') {
            Object.assign(svelteStore, mapDispatchToStore(store.dispatch));
        }
        else {
            Object.assign(svelteStore, bindActionCreators(mapDispatchToStore, store.dispatch));
        }
        return svelteStore;
    };
}
export function bindConnect(store) {
    return connect.bind(null, store);
}
